/* 
 * File:   Init.h
 * Initialisierung
 */

#ifndef INIT_H
#define	INIT_H

/**/
void init(void) {
    INTCON = 0b10100000; //GIE,PEIE,TMR0IE,INTE(RB0),RBIE(4-7),TMR0IF,INTF(RB0),RBIF(4-7)
    TRISA = 0b00011111; //7-6unim.,5Status-LED,4..0 Input
    //RA4 ist open drain, das macht Pull-up Widerstand (PU) ntig.
    TRISB = 0b00000000; //7PGD,6PGC,5..2LCD-Dat,1..0n.b.
    TRISC = 0b00011000; //7..5LCD-Steuer,4..3I2C,2..0n.b.
    ADCON0 = 0b10000000; //ADCS1 ADCS0(10)=FOSC/32, CHS2 CHS1 CHS0(000)=Channel 0, GO/DONE, ?, ADON aus
    ADCON1 = 0b00000110; //7Left justified,6FOSC/32,5-4unim.,(0010)RA5 Digital,RA4..0 Analog S.128
    CMCON = 0b00000111; //Disable Comparator module's
    OPTION_REG = 0b00000111; //7Pullup en.,Prescaler 1:256
    //PWM-Mode s.S67
    SSPSTAT = 0b10000000;// Slew rate control enabled for
    // standard speed mode (1MHz)
    SSPCON = 0b00110110; //Enable serial port, release Clock
    //xxxx0110 = I2C Slave mode, 7-bit-Adresse
    //SSPCON2, SEN ist das einzige was gebraucht wird vom Slave s.u.
    SEN = 1; //enable clock stretching
    SSPEN = 1; //SSP enable
    SSPIF = 0; //IC Port Interrupt Flag
    SSPIE = 1; //IC Port Interrupt enable
    SMP = 1; //1MHz standard speed mode
    SSPADD = 20<<1; //slave address = 20, wird aber um eine Stelle nach links 
    //verschoben bertragen, weil das LSB R_nW ist
    BCLIF = 0;   // Clear the bus collision interrupt flag
    BCLIE = 1;   // Enable bus collision interrupts
    PEIE = 1; //Periphel Interrupt enable
    GIE = 1; //General Interupt enable
    TMR0 = 0; //Brauchts manchmal, damit der Prescaler geht.
    //
}

#endif	/* INIT_H */

